﻿using FLY.OBJComponents.Client;
using FLY.Weight.Client;
using FLY.Weight.IService;
using MultiLayout.UiModule;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Unity;

namespace FLY.Weight.UI.Client.UiModule
{
    /// <summary>
    /// UcWeighterItem.xaml 的交互逻辑
    /// </summary>
    public partial class UcWeighterItem : UserControl
    {
        #region DependencyProperty
        // Using a DependencyProperty as the backing store for WeightSystemService.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty WeightSystemServiceProperty =
            DependencyProperty.Register(nameof(WeightSystemService), typeof(IWeightSystemService), typeof(UcWeighterItem), new PropertyMetadata(null));

        public IWeightSystemService WeightSystemService
        {
            get { return (IWeightSystemService)GetValue(WeightSystemServiceProperty); }
            set { SetValue(WeightSystemServiceProperty, value); }
        }

        public static readonly DependencyProperty ContainerProperty =
            DependencyProperty.Register(nameof(Container), typeof(IUnityContainer), typeof(UcWeighterItem), new PropertyMetadata(null));

        public IUnityContainer Container
        {
            get { return (IUnityContainer)GetValue(ContainerProperty); }
            set { SetValue(ContainerProperty, value); }
        }
        #endregion

        SetPLCUpdatePlan plan;
        int Index = 0;

        public UcWeighterItem()
        {
            InitializeComponent();
        }

        public static string[] item_update_propertynames = new string[] {
           // "CumulativeProduction",
            nameof(Common.WeighterC.FlowSetting),
            nameof(Common.WeighterC.CurrentFlow),
            nameof(Common.WeighterC.ScrewPDisp),
            nameof(Common.WeighterC.ScrewPSet),
            nameof(Common.WeighterC.ScrewPDisp),
            nameof(Common.WeighterC.MixBucketWeight),
            nameof(Common.WeighterC.BinWeight),
            nameof(Common.WeighterC.MixIsOn),
            nameof(Common.WeighterC.BucketValveIsOpen),
            nameof(Common.WeighterC.ScrewMotorFreq),
            nameof(Common.WeighterC.ScrewMotorIsOn),
            nameof(Common.WeighterC.ScrewIsAutoMode),
            nameof(Common.WeighterC.ScrewManualFreq),
            nameof(Common.WeighterC.ScrewManualFreqIsSet)
        };

        private void button_frequency_Click(object sender, RoutedEventArgs e)
        {
            WdFrequency w = new WdFrequency();
            var weight = ((Button)sender).Tag as FLY.Weight.Common.WeighterC;
            w.Init(WeightSystemService, weight);
            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);
            w.ShowDialog();
        }

        private void button_ratio_Click(object sender, RoutedEventArgs e)
        {
            WdRatioSet w = new WdRatioSet();
            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);
            w.Init(WeightSystemService);
            w.ShowDialog();
        }

        private void button_ingredient_Click(object sender, RoutedEventArgs e)
        {
            FLY.Weight.Common.WeighterC weight = ((Button)sender).Tag as FLY.Weight.Common.WeighterC;
            if (weight.IsSingle) {
                //单组份，没有配料
                return;
            }
            WdIngredient w = new WdIngredient();
            
            w.Init(Container, weight, WeightSystemService);

            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);
            w.ShowDialog();
        }
    }

    /// <summary>
    /// 全部扫描图的参数
    /// </summary>
    public class WeighterItemParams 
    {
        public Dictionary<int, int> Indexs = new Dictionary<int, int>();
        public WeighterItemParams()
        {
        }
        public static WeighterItemParams Current { get; } = new WeighterItemParams();
    }

}
