﻿using FLY.OBJComponents.Client;
using FLY.Weight.IService;
using MultiLayout.UiModule;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Unity;

namespace FLY.Weight.UI.Client.UiModule
{
    /// <summary>
    /// UcThickness.xaml 的交互逻辑
    /// </summary>
    public partial class UcThicknessV4 : UserControl
    {

        IWeightSystemService weightSystemService;

        SetPLCUpdatePlan setPlan_accessory;

        public UcThicknessV4()
        {
            InitializeComponent();
        }
        public void Init(IWeightSystemService weightSystemService)
        {
            this.weightSystemService = weightSystemService;
            this.DataContext = this.weightSystemService;
            string objname = nameof(IWeightSystemService.Accessory);
            setPlan_accessory = new SetPLCUpdatePlan(
                this.weightSystemService.PLCos,
                objname,
                new string[] {
                    nameof(this.weightSystemService.Accessory.Thickness4),
                    nameof(this.weightSystemService.Accessory.CurrentVelocity4),
                    nameof(this.weightSystemService.Accessory.TargetVelocity4),
                    nameof(this.weightSystemService.Accessory.SetThickness),
                    nameof(this.weightSystemService.Accessory.TotalFilmWidth),
                    nameof(this.weightSystemService.Accessory.Density),
                    nameof(this.weightSystemService.Accessory.TotalFlowSetting4),
                    nameof(this.weightSystemService.Accessory.IsSync4),
                    nameof(this.weightSystemService.Accessory.IsEnter4)
                });
        }



        private void btnThicknessClick(object sender, RoutedEventArgs e)
        {
            WdThicknessV4 w = new WdThicknessV4();
            if (weightSystemService.Items.Count() < 1)
                return;

            w.SetThickness = (int)weightSystemService.Accessory.SetThickness;
            w.FilmWidth = (int)weightSystemService.Accessory.TotalFilmWidth;
            w.Density = weightSystemService.Accessory.Density;
            w.TotalFlowSetting = weightSystemService.Accessory.TotalFlowSetting4;
            w.IsSync = weightSystemService.Accessory.IsSync4;

            w.Owner = FLY.ControlLibrary.COMMON.GetWindow(this);

            if (w.ShowDialog() == true)
            {
                weightSystemService.Accessory.SetThickness = w.SetThickness;
                weightSystemService.Accessory.TotalFilmWidth = w.FilmWidth;
                weightSystemService.Accessory.Density = (float)w.Density;
                weightSystemService.Accessory.TotalFlowSetting4 = (float)w.TotalFlowSetting;
                weightSystemService.Accessory.IsSync4 = w.IsSync;
                weightSystemService.Accessory.IsEnter4 = true;

                FLY.ControlLibrary.Window_Tip.Show("", "厚度参数设置成功", TimeSpan.FromSeconds(2));
            }
        }
    }
}
